// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 34 "src/parser.yy"

#include <iostream>

#include "driver.h"
#include "lexer.h"

void yyerror(bpftrace::Driver &driver, const char *s);

#line 50 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"


#include "parser.tab.hh"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 4 "src/parser.yy"
namespace  bpftrace  {
#line 148 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"

  /// Build a parser object.
   Parser :: Parser  (bpftrace::Driver &driver_yyarg, void *yyscanner_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      yyscanner (yyscanner_yyarg)
  {}

   Parser ::~ Parser  ()
  {}

   Parser ::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------.
  | symbol.  |
  `---------*/



  // by_state.
   Parser ::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

   Parser ::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
   Parser ::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
   Parser ::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

   Parser ::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

   Parser ::symbol_kind_type
   Parser ::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

   Parser ::stack_symbol_type::stack_symbol_type ()
  {}

   Parser ::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_attach_point: // attach_point
        value.YY_MOVE_OR_COPY< ast::AttachPoint * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.YY_MOVE_OR_COPY< ast::AttachPointList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_call: // call
        value.YY_MOVE_OR_COPY< ast::Call * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_arith_expr: // arith_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.YY_MOVE_OR_COPY< ast::Expression * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vargs: // vargs
        value.YY_MOVE_OR_COPY< ast::ExpressionList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_int: // int
        value.YY_MOVE_OR_COPY< ast::Integer * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map: // map
        value.YY_MOVE_OR_COPY< ast::Map * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.YY_MOVE_OR_COPY< ast::Operator > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_param: // param
        value.YY_MOVE_OR_COPY< ast::PositionalParameter * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pred: // pred
        value.YY_MOVE_OR_COPY< ast::Predicate * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probe: // probe
        value.YY_MOVE_OR_COPY< ast::Probe * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probes: // probes
        value.YY_MOVE_OR_COPY< ast::ProbeList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.YY_MOVE_OR_COPY< ast::Statement * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.YY_MOVE_OR_COPY< ast::StatementList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_var: // var
        value.YY_MOVE_OR_COPY< ast::Variable * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_INT: // "integer"
        value.YY_MOVE_OR_COPY< long > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

   Parser ::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_attach_point: // attach_point
        value.move< ast::AttachPoint * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.move< ast::AttachPointList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_call: // call
        value.move< ast::Call * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_arith_expr: // arith_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.move< ast::Expression * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vargs: // vargs
        value.move< ast::ExpressionList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_int: // int
        value.move< ast::Integer * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map: // map
        value.move< ast::Map * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.move< ast::Operator > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_param: // param
        value.move< ast::PositionalParameter * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pred: // pred
        value.move< ast::Predicate * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probe: // probe
        value.move< ast::Probe * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probes: // probes
        value.move< ast::ProbeList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.move< ast::Statement * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.move< ast::StatementList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_var: // var
        value.move< ast::Variable * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_INT: // "integer"
        value.move< long > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.move< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
   Parser ::stack_symbol_type&
   Parser ::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_attach_point: // attach_point
        value.copy< ast::AttachPoint * > (that.value);
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.copy< ast::AttachPointList * > (that.value);
        break;

      case symbol_kind::S_call: // call
        value.copy< ast::Call * > (that.value);
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_arith_expr: // arith_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.copy< ast::Expression * > (that.value);
        break;

      case symbol_kind::S_vargs: // vargs
        value.copy< ast::ExpressionList * > (that.value);
        break;

      case symbol_kind::S_int: // int
        value.copy< ast::Integer * > (that.value);
        break;

      case symbol_kind::S_map: // map
        value.copy< ast::Map * > (that.value);
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.copy< ast::Operator > (that.value);
        break;

      case symbol_kind::S_param: // param
        value.copy< ast::PositionalParameter * > (that.value);
        break;

      case symbol_kind::S_pred: // pred
        value.copy< ast::Predicate * > (that.value);
        break;

      case symbol_kind::S_probe: // probe
        value.copy< ast::Probe * > (that.value);
        break;

      case symbol_kind::S_probes: // probes
        value.copy< ast::ProbeList * > (that.value);
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.copy< ast::Statement * > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.copy< ast::StatementList * > (that.value);
        break;

      case symbol_kind::S_var: // var
        value.copy< ast::Variable * > (that.value);
        break;

      case symbol_kind::S_INT: // "integer"
        value.copy< long > (that.value);
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.copy< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

   Parser ::stack_symbol_type&
   Parser ::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_attach_point: // attach_point
        value.move< ast::AttachPoint * > (that.value);
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.move< ast::AttachPointList * > (that.value);
        break;

      case symbol_kind::S_call: // call
        value.move< ast::Call * > (that.value);
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_arith_expr: // arith_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.move< ast::Expression * > (that.value);
        break;

      case symbol_kind::S_vargs: // vargs
        value.move< ast::ExpressionList * > (that.value);
        break;

      case symbol_kind::S_int: // int
        value.move< ast::Integer * > (that.value);
        break;

      case symbol_kind::S_map: // map
        value.move< ast::Map * > (that.value);
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.move< ast::Operator > (that.value);
        break;

      case symbol_kind::S_param: // param
        value.move< ast::PositionalParameter * > (that.value);
        break;

      case symbol_kind::S_pred: // pred
        value.move< ast::Predicate * > (that.value);
        break;

      case symbol_kind::S_probe: // probe
        value.move< ast::Probe * > (that.value);
        break;

      case symbol_kind::S_probes: // probes
        value.move< ast::ProbeList * > (that.value);
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.move< ast::Statement * > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.move< ast::StatementList * > (that.value);
        break;

      case symbol_kind::S_var: // var
        value.move< ast::Variable * > (that.value);
        break;

      case symbol_kind::S_INT: // "integer"
        value.move< long > (that.value);
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.move< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
   Parser ::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
   Parser ::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
   Parser ::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
   Parser ::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
   Parser ::yypop_ (int n) YY_NOEXCEPT
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
   Parser ::debug_stream () const
  {
    return *yycdebug_;
  }

  void
   Parser ::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


   Parser ::debug_level_type
   Parser ::debug_level () const
  {
    return yydebug_;
  }

  void
   Parser ::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

   Parser ::state_type
   Parser ::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
   Parser ::yy_pact_value_is_default_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yypact_ninf_;
  }

  bool
   Parser ::yy_table_value_is_error_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yytable_ninf_;
  }

  int
   Parser ::operator() ()
  {
    return parse ();
  }

  int
   Parser ::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            symbol_type yylookahead (yylex (driver, yyscanner));
            yyla.move (yylookahead);
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_attach_point: // attach_point
        yylhs.value.emplace< ast::AttachPoint * > ();
        break;

      case symbol_kind::S_attach_points: // attach_points
        yylhs.value.emplace< ast::AttachPointList * > ();
        break;

      case symbol_kind::S_call: // call
        yylhs.value.emplace< ast::Call * > ();
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_arith_expr: // arith_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        yylhs.value.emplace< ast::Expression * > ();
        break;

      case symbol_kind::S_vargs: // vargs
        yylhs.value.emplace< ast::ExpressionList * > ();
        break;

      case symbol_kind::S_int: // int
        yylhs.value.emplace< ast::Integer * > ();
        break;

      case symbol_kind::S_map: // map
        yylhs.value.emplace< ast::Map * > ();
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        yylhs.value.emplace< ast::Operator > ();
        break;

      case symbol_kind::S_param: // param
        yylhs.value.emplace< ast::PositionalParameter * > ();
        break;

      case symbol_kind::S_pred: // pred
        yylhs.value.emplace< ast::Predicate * > ();
        break;

      case symbol_kind::S_probe: // probe
        yylhs.value.emplace< ast::Probe * > ();
        break;

      case symbol_kind::S_probes: // probes
        yylhs.value.emplace< ast::ProbeList * > ();
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        yylhs.value.emplace< ast::Statement * > ();
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        yylhs.value.emplace< ast::StatementList * > ();
        break;

      case symbol_kind::S_var: // var
        yylhs.value.emplace< ast::Variable * > ();
        break;

      case symbol_kind::S_INT: // "integer"
        yylhs.value.emplace< long > ();
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        yylhs.value.emplace< std::string > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // program: c_definitions probes "end of file"
#line 162 "src/parser.yy"
                                         { driver.root_ = new ast::Program(yystack_[2].value.as < std::string > (), yystack_[1].value.as < ast::ProbeList * > ()); }
#line 1078 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 3: // c_definitions: "preprocessor directive" c_definitions
#line 166 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "\n" + yystack_[0].value.as < std::string > (); }
#line 1084 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 4: // c_definitions: "struct definition" c_definitions
#line 167 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ";\n" + yystack_[0].value.as < std::string > (); }
#line 1090 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 5: // c_definitions: "enum" c_definitions
#line 168 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ";\n" + yystack_[0].value.as < std::string > (); }
#line 1096 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 6: // c_definitions: %empty
#line 169 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = std::string(); }
#line 1102 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 7: // probes: probes probe
#line 173 "src/parser.yy"
                             { yylhs.value.as < ast::ProbeList * > () = yystack_[1].value.as < ast::ProbeList * > (); yystack_[1].value.as < ast::ProbeList * > ()->push_back(yystack_[0].value.as < ast::Probe * > ()); }
#line 1108 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 8: // probes: probe
#line 174 "src/parser.yy"
                             { yylhs.value.as < ast::ProbeList * > () = new ast::ProbeList; yylhs.value.as < ast::ProbeList * > ()->push_back(yystack_[0].value.as < ast::Probe * > ()); }
#line 1114 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 9: // probe: attach_points pred block
#line 179 "src/parser.yy"
                {
                  if (!driver.listing_)
                    yylhs.value.as < ast::Probe * > () = new ast::Probe(yystack_[2].value.as < ast::AttachPointList * > (), yystack_[1].value.as < ast::Predicate * > (), yystack_[0].value.as < ast::StatementList * > ());
                  else
                  {
                    error(yylhs.location, "unexpected listing query format");
                    YYERROR;
                  }
                }
#line 1128 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 10: // probe: attach_points "end of file"
#line 189 "src/parser.yy"
                {
                  if (driver.listing_)
                    yylhs.value.as < ast::Probe * > () = new ast::Probe(yystack_[1].value.as < ast::AttachPointList * > (), nullptr, nullptr);
                  else
                  {
                    error(yylhs.location, "unexpected end of file, expected {");
                    YYERROR;
                  }
                }
#line 1142 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 11: // attach_points: attach_points "," attach_point
#line 201 "src/parser.yy"
                                               { yylhs.value.as < ast::AttachPointList * > () = yystack_[2].value.as < ast::AttachPointList * > (); yystack_[2].value.as < ast::AttachPointList * > ()->push_back(yystack_[0].value.as < ast::AttachPoint * > ()); }
#line 1148 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 12: // attach_points: attach_point
#line 202 "src/parser.yy"
                                               { yylhs.value.as < ast::AttachPointList * > () = new ast::AttachPointList; yylhs.value.as < ast::AttachPointList * > ()->push_back(yystack_[0].value.as < ast::AttachPoint * > ()); }
#line 1154 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 13: // attach_point: attach_point_def
#line 206 "src/parser.yy"
                                                { yylhs.value.as < ast::AttachPoint * > () = new ast::AttachPoint(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1160 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 14: // attach_point_def: attach_point_def ident
#line 210 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + yystack_[0].value.as < std::string > (); }
#line 1166 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 15: // attach_point_def: attach_point_def "string"
#line 214 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "\"" + std::regex_replace(yystack_[0].value.as < std::string > (), std::regex("\""), "\\\"") + "\""; }
#line 1172 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 16: // attach_point_def: attach_point_def "path"
#line 215 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + yystack_[0].value.as < std::string > (); }
#line 1178 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 17: // attach_point_def: attach_point_def "integer"
#line 216 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + std::to_string(yystack_[0].value.as < long > ()); }
#line 1184 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 18: // attach_point_def: attach_point_def ":"
#line 217 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ":"; }
#line 1190 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 19: // attach_point_def: attach_point_def "."
#line 218 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "."; }
#line 1196 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 20: // attach_point_def: attach_point_def "+"
#line 219 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "+"; }
#line 1202 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 21: // attach_point_def: attach_point_def "*"
#line 220 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "*"; }
#line 1208 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 22: // attach_point_def: attach_point_def "["
#line 221 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "["; }
#line 1214 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 23: // attach_point_def: attach_point_def "]"
#line 222 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "]"; }
#line 1220 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 24: // attach_point_def: attach_point_def param
#line 224 "src/parser.yy"
                {
                  if (yystack_[0].value.as < ast::PositionalParameter * > ()->ptype != PositionalParameterType::positional)
                  {
                    error(yylhs.location, "Not a positional parameter");
                    YYERROR;
                  }
                  // "Un-parse" the positional parameter back into text so
                  // we can give it to the AttachPointParser. This is kind of
                  // a hack but there doesn't look to be any other way.
                  yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "$" + std::to_string(yystack_[0].value.as < ast::PositionalParameter * > ()->n);
                  delete yystack_[0].value.as < ast::PositionalParameter * > ();
                }
#line 1237 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 25: // attach_point_def: %empty
#line 236 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = ""; }
#line 1243 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 26: // pred: "/" expr "end predicate"
#line 240 "src/parser.yy"
                                 { yylhs.value.as < ast::Predicate * > () = new ast::Predicate(yystack_[1].value.as < ast::Expression * > (), yylhs.location); }
#line 1249 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 27: // pred: %empty
#line 241 "src/parser.yy"
                                  { yylhs.value.as < ast::Predicate * > () = nullptr; }
#line 1255 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 28: // param: "positional parameter"
#line 246 "src/parser.yy"
                      {
                        try {
                          long n = std::stol(yystack_[0].value.as < std::string > ().substr(1, yystack_[0].value.as < std::string > ().size()-1));
                          if (n == 0) throw std::exception();
                          yylhs.value.as < ast::PositionalParameter * > () = new ast::PositionalParameter(PositionalParameterType::positional, n, yylhs.location);
                        } catch (std::exception const& e) {
                          error(yystack_[0].location, "param " + yystack_[0].value.as < std::string > () + " is out of integer range [1, " +
                                std::to_string(std::numeric_limits<long>::max()) + "]");
                          YYERROR;
                        }
                      }
#line 1271 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 29: // param: "$#"
#line 257 "src/parser.yy"
                           { yylhs.value.as < ast::PositionalParameter * > () = new ast::PositionalParameter(PositionalParameterType::count, 0, yylhs.location); }
#line 1277 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 30: // block: "{" stmt_list "}"
#line 261 "src/parser.yy"
                                      { yylhs.value.as < ast::StatementList * > () = yystack_[1].value.as < ast::StatementList * > (); }
#line 1283 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 31: // stmt_list: expr_stmt ";" stmt_list
#line 268 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); yystack_[0].value.as < ast::StatementList * > ()->insert(yystack_[0].value.as < ast::StatementList * > ()->begin(), yystack_[2].value.as < ast::Statement * > ()); }
#line 1289 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 32: // stmt_list: expr_stmt
#line 269 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; yylhs.value.as < ast::StatementList * > ()->push_back(yystack_[0].value.as < ast::Statement * > ()); }
#line 1295 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 33: // stmt_list: block_stmt stmt_list
#line 273 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); yystack_[0].value.as < ast::StatementList * > ()->insert(yystack_[0].value.as < ast::StatementList * > ()->begin(), yystack_[1].value.as < ast::Statement * > ()); }
#line 1301 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 34: // stmt_list: %empty
#line 274 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; }
#line 1307 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 35: // block_stmt: loop_stmt
#line 278 "src/parser.yy"
                             { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1313 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 36: // block_stmt: if_stmt
#line 279 "src/parser.yy"
                             { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1319 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 37: // expr_stmt: expr
#line 283 "src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = new ast::ExprStatement(yystack_[0].value.as < ast::Expression * > (), yystack_[0].location); }
#line 1325 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 38: // expr_stmt: jump_stmt
#line 284 "src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1331 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 39: // expr_stmt: assign_stmt
#line 289 "src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1337 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 40: // jump_stmt: "break"
#line 293 "src/parser.yy"
                         { yylhs.value.as < ast::Statement * > () = new ast::Jump(ast::JumpType::BREAK, yylhs.location); }
#line 1343 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 41: // jump_stmt: "continue"
#line 294 "src/parser.yy"
                         { yylhs.value.as < ast::Statement * > () = new ast::Jump(ast::JumpType::CONTINUE, yylhs.location); }
#line 1349 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 42: // jump_stmt: "return"
#line 295 "src/parser.yy"
                         { yylhs.value.as < ast::Statement * > () = new ast::Jump(ast::JumpType::RETURN, yylhs.location); }
#line 1355 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 43: // loop_stmt: "unroll" "(" int ")" block
#line 299 "src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = new ast::Unroll(yystack_[2].value.as < ast::Integer * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location + yystack_[1].location); }
#line 1361 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 44: // loop_stmt: "unroll" "(" param ")" block
#line 300 "src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = new ast::Unroll(yystack_[2].value.as < ast::PositionalParameter * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location + yystack_[1].location); }
#line 1367 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 45: // loop_stmt: "while" "(" expr ")" block
#line 301 "src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = new ast::While(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location); }
#line 1373 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 46: // if_stmt: "if" "(" expr ")" block
#line 305 "src/parser.yy"
                                                       { yylhs.value.as < ast::Statement * > () = new ast::If(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1379 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 47: // if_stmt: "if" "(" expr ")" block "else" block_or_if
#line 306 "src/parser.yy"
                                                       { yylhs.value.as < ast::Statement * > () = new ast::If(yystack_[4].value.as < ast::Expression * > (), yystack_[2].value.as < ast::StatementList * > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1385 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 48: // block_or_if: block
#line 310 "src/parser.yy"
                             { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); }
#line 1391 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 49: // block_or_if: if_stmt
#line 311 "src/parser.yy"
                             { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; yylhs.value.as < ast::StatementList * > ()->emplace_back(yystack_[0].value.as < ast::Statement * > ()); }
#line 1397 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 50: // assign_stmt: tuple_access_expr "=" expr
#line 316 "src/parser.yy"
                {
                  error(yystack_[2].location + yystack_[0].location, "Tuples are immutable once created. Consider creating a new tuple and assigning it instead.");
                  YYERROR;
                }
#line 1406 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 51: // assign_stmt: map "=" expr
#line 320 "src/parser.yy"
                                     { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), yystack_[0].value.as < ast::Expression * > (), false, yystack_[1].location); }
#line 1412 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 52: // assign_stmt: var "=" expr
#line 321 "src/parser.yy"
                                     { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), yystack_[0].value.as < ast::Expression * > (), false, yystack_[1].location); }
#line 1418 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 53: // assign_stmt: map compound_op unary_expr
#line 323 "src/parser.yy"
                {
                  auto b = new ast::Binop(yystack_[2].value.as < ast::Map * > (), yystack_[1].value.as < ast::Operator > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location);
                  yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), b, true, yylhs.location);
                }
#line 1427 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 54: // assign_stmt: var compound_op unary_expr
#line 328 "src/parser.yy"
                {
                  auto b = new ast::Binop(yystack_[2].value.as < ast::Variable * > (), yystack_[1].value.as < ast::Operator > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location);
                  yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), b, true, yylhs.location);
                }
#line 1436 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 55: // primary_expr: "identifier"
#line 335 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::Identifier(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1442 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 56: // primary_expr: int
#line 336 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Integer * > (); }
#line 1448 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 57: // primary_expr: "string"
#line 337 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::String(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1454 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 58: // primary_expr: "stack_mode"
#line 338 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::StackMode(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1460 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 59: // primary_expr: "builtin"
#line 339 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::Builtin(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1466 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 60: // primary_expr: "call_builtin"
#line 340 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::Builtin(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1472 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 61: // primary_expr: "(" expr ")"
#line 341 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[1].value.as < ast::Expression * > (); }
#line 1478 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 62: // primary_expr: param
#line 342 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::PositionalParameter * > (); }
#line 1484 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 63: // primary_expr: map_or_var
#line 343 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1490 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 64: // primary_expr: "(" expr "," vargs ")"
#line 345 "src/parser.yy"
                {
                  auto args = new ast::ExpressionList;
                  args->emplace_back(yystack_[3].value.as < ast::Expression * > ());
                  args->insert(args->end(), yystack_[1].value.as < ast::ExpressionList * > ()->begin(), yystack_[1].value.as < ast::ExpressionList * > ()->end());
                  yylhs.value.as < ast::Expression * > () = new ast::Tuple(args, yylhs.location);
                }
#line 1501 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 65: // postfix_expr: primary_expr
#line 354 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1507 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 66: // postfix_expr: postfix_expr "." ident
#line 356 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < std::string > (), yystack_[1].location); }
#line 1513 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 67: // postfix_expr: postfix_expr "->" ident
#line 357 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(new ast::Unop(ast::Operator::MUL, yystack_[2].value.as < ast::Expression * > (), yystack_[1].location), yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1519 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 68: // postfix_expr: tuple_access_expr
#line 359 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1525 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 69: // postfix_expr: postfix_expr "[" expr "]"
#line 361 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::ArrayAccess(yystack_[3].value.as < ast::Expression * > (), yystack_[1].value.as < ast::Expression * > (), yystack_[2].location + yystack_[0].location); }
#line 1531 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 70: // postfix_expr: call
#line 362 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Call * > (); }
#line 1537 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 71: // postfix_expr: map_or_var "++"
#line 363 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::Unop(ast::Operator::INCREMENT, yystack_[1].value.as < ast::Expression * > (), true, yystack_[0].location); }
#line 1543 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 72: // postfix_expr: map_or_var "--"
#line 364 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::Unop(ast::Operator::DECREMENT, yystack_[1].value.as < ast::Expression * > (), true, yystack_[0].location); }
#line 1549 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 73: // postfix_expr: "++" ident
#line 366 "src/parser.yy"
                                          { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 1555 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 74: // postfix_expr: "--" ident
#line 367 "src/parser.yy"
                                          { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 1561 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 75: // tuple_access_expr: postfix_expr "." "integer"
#line 372 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < long > (), yystack_[0].location); }
#line 1567 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 76: // unary_expr: unary_op cast_expr
#line 378 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(yystack_[1].value.as < ast::Operator > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1573 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 77: // unary_expr: postfix_expr
#line 379 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1579 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 78: // unary_expr: "++" map_or_var
#line 380 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(ast::Operator::INCREMENT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1585 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 79: // unary_expr: "--" map_or_var
#line 381 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(ast::Operator::DECREMENT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1591 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 80: // unary_expr: ident "--"
#line 383 "src/parser.yy"
                                     { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 1597 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 81: // unary_expr: ident "++"
#line 384 "src/parser.yy"
                                     { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 1603 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 82: // unary_op: "*"
#line 388 "src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::MUL; }
#line 1609 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 83: // unary_op: "~"
#line 389 "src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::BNOT; }
#line 1615 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 84: // unary_op: "!"
#line 390 "src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::LNOT; }
#line 1621 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 85: // unary_op: "-"
#line 391 "src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::MINUS; }
#line 1627 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 86: // expr: conditional_expr
#line 395 "src/parser.yy"
                                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1633 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 87: // conditional_expr: logical_or_expr
#line 399 "src/parser.yy"
                                                                 { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1639 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 88: // conditional_expr: logical_or_expr "?" expr ":" conditional_expr
#line 400 "src/parser.yy"
                                                                 { yylhs.value.as < ast::Expression * > () = new ast::Ternary(yystack_[4].value.as < ast::Expression * > (), yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::Expression * > (), yylhs.location); }
#line 1645 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 89: // logical_or_expr: logical_and_expr
#line 405 "src/parser.yy"
                                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1651 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 90: // logical_or_expr: logical_or_expr "||" logical_and_expr
#line 406 "src/parser.yy"
                                                     { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1657 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 91: // logical_and_expr: or_expr
#line 410 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1663 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 92: // logical_and_expr: logical_and_expr "&&" or_expr
#line 411 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LAND, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1669 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 93: // or_expr: xor_expr
#line 415 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1675 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 94: // or_expr: or_expr "|" xor_expr
#line 416 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::BOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1681 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 95: // xor_expr: and_expr
#line 420 "src/parser.yy"
                                       { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1687 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 96: // xor_expr: xor_expr "^" and_expr
#line 421 "src/parser.yy"
                                       { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::BXOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1693 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 97: // and_expr: equality_expr
#line 426 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1699 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 98: // and_expr: and_expr "&" equality_expr
#line 427 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::BAND, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1705 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 99: // equality_expr: relational_expr
#line 431 "src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1711 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 100: // equality_expr: equality_expr "==" relational_expr
#line 432 "src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::EQ, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1717 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 101: // equality_expr: equality_expr "!=" relational_expr
#line 433 "src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::NE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1723 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 102: // relational_expr: shift_expr
#line 437 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1729 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 103: // relational_expr: relational_expr "<=" shift_expr
#line 438 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1735 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 104: // relational_expr: relational_expr ">=" shift_expr
#line 439 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::GE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1741 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 105: // relational_expr: relational_expr "<" shift_expr
#line 440 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1747 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 106: // relational_expr: relational_expr ">" shift_expr
#line 441 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::GT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1753 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 107: // shift_expr: arith_expr
#line 445 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1759 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 108: // shift_expr: shift_expr "<<" arith_expr
#line 446 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LEFT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1765 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 109: // shift_expr: shift_expr ">>" arith_expr
#line 447 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::RIGHT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1771 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 110: // arith_expr: cast_expr
#line 451 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1777 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 111: // arith_expr: arith_expr "+" cast_expr
#line 452 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::PLUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1783 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 112: // arith_expr: arith_expr "-" cast_expr
#line 453 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::MINUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1789 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 113: // arith_expr: arith_expr "*" cast_expr
#line 454 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::MUL, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1795 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 114: // arith_expr: arith_expr "/" cast_expr
#line 455 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::DIV, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1801 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 115: // arith_expr: arith_expr "%" cast_expr
#line 456 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::MOD, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1807 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 116: // cast_expr: unary_expr
#line 460 "src/parser.yy"
                                                      { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1813 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 117: // cast_expr: "(" "identifier" ")" cast_expr
#line 461 "src/parser.yy"
                                                      { yylhs.value.as < ast::Expression * > () = new ast::Cast(yystack_[2].value.as < std::string > (), false, false, yystack_[0].value.as < ast::Expression * > (), yystack_[3].location + yystack_[1].location); }
#line 1819 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 118: // cast_expr: "(" "identifier" "*" ")" cast_expr
#line 462 "src/parser.yy"
                                                      { yylhs.value.as < ast::Expression * > () = new ast::Cast(yystack_[3].value.as < std::string > (), true, false, yystack_[0].value.as < ast::Expression * > (), yystack_[4].location + yystack_[2].location); }
#line 1825 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 119: // cast_expr: "(" "identifier" "*" "*" ")" cast_expr
#line 463 "src/parser.yy"
                                                      { yylhs.value.as < ast::Expression * > () = new ast::Cast(yystack_[4].value.as < std::string > (), true, true, yystack_[0].value.as < ast::Expression * > (), yystack_[5].location + yystack_[3].location); }
#line 1831 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 120: // int: "-" "integer"
#line 467 "src/parser.yy"
                             { yylhs.value.as < ast::Integer * > () = new ast::Integer((long)(~(unsigned long)(yystack_[0].value.as < long > ()) + 1), yylhs.location); }
#line 1837 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 121: // int: "integer"
#line 468 "src/parser.yy"
                             { yylhs.value.as < ast::Integer * > () = new ast::Integer(yystack_[0].value.as < long > (), yylhs.location); }
#line 1843 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 122: // ident: "identifier"
#line 472 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1849 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 123: // ident: "builtin"
#line 473 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1855 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 124: // ident: "call"
#line 474 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1861 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 125: // ident: "call_builtin"
#line 475 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1867 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 126: // ident: "stack_mode"
#line 476 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1873 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 127: // call: "call" "(" ")"
#line 480 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[2].value.as < std::string > (), yylhs.location); }
#line 1879 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 128: // call: "call" "(" vargs ")"
#line 481 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 1885 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 129: // call: "call_builtin" "(" ")"
#line 482 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[2].value.as < std::string > (), yylhs.location); }
#line 1891 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 130: // call: "call_builtin" "(" vargs ")"
#line 483 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 1897 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 131: // call: "identifier" "(" ")"
#line 484 "src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 1903 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 132: // call: "identifier" "(" vargs ")"
#line 485 "src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 1909 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 133: // call: "builtin" "(" ")"
#line 486 "src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 1915 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 134: // call: "builtin" "(" vargs ")"
#line 487 "src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 1921 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 135: // call: "stack_mode" "(" ")"
#line 488 "src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 1927 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 136: // call: "stack_mode" "(" vargs ")"
#line 489 "src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 1933 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 137: // map: "map"
#line 493 "src/parser.yy"
                                  { yylhs.value.as < ast::Map * > () = new ast::Map(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1939 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 138: // map: "map" "[" vargs "]"
#line 494 "src/parser.yy"
                                  { yylhs.value.as < ast::Map * > () = new ast::Map(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 1945 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 139: // var: "variable"
#line 498 "src/parser.yy"
                    { yylhs.value.as < ast::Variable * > () = new ast::Variable(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1951 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 140: // map_or_var: var
#line 502 "src/parser.yy"
                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Variable * > (); }
#line 1957 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 141: // map_or_var: map
#line 503 "src/parser.yy"
                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Map * > (); }
#line 1963 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 142: // vargs: vargs "," expr
#line 507 "src/parser.yy"
                               { yylhs.value.as < ast::ExpressionList * > () = yystack_[2].value.as < ast::ExpressionList * > (); yystack_[2].value.as < ast::ExpressionList * > ()->push_back(yystack_[0].value.as < ast::Expression * > ()); }
#line 1969 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 143: // vargs: expr
#line 508 "src/parser.yy"
                               { yylhs.value.as < ast::ExpressionList * > () = new ast::ExpressionList; yylhs.value.as < ast::ExpressionList * > ()->push_back(yystack_[0].value.as < ast::Expression * > ()); }
#line 1975 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 144: // compound_op: "<<="
#line 512 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::LEFT; }
#line 1981 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 145: // compound_op: "&="
#line 513 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::BAND; }
#line 1987 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 146: // compound_op: "|="
#line 514 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::BOR; }
#line 1993 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 147: // compound_op: "^="
#line 515 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::BXOR; }
#line 1999 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 148: // compound_op: "/="
#line 516 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::DIV; }
#line 2005 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 149: // compound_op: "-="
#line 517 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::MINUS; }
#line 2011 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 150: // compound_op: "%="
#line 518 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::MOD; }
#line 2017 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 151: // compound_op: "*="
#line 519 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::MUL; }
#line 2023 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 152: // compound_op: "+="
#line 520 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::PLUS; }
#line 2029 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;

  case 153: // compound_op: ">>="
#line 521 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::RIGHT; }
#line 2035 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"
    break;


#line 2039 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
   Parser ::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
   Parser ::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
   Parser ::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  //  Parser ::context.
   Parser ::context::context (const  Parser & yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
   Parser ::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    const int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        const int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        const int yychecklim = yylast_ - yyn + 1;
        const int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }






  int
   Parser ::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
   Parser ::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const signed char  Parser ::yypact_ninf_ = -126;

  const signed char  Parser ::yytable_ninf_ = -127;

  const short
   Parser ::yypact_[] =
  {
     115,   115,   115,   115,    14,  -126,  -126,  -126,  -126,  -126,
      39,  -126,    11,  -126,    66,  -126,  -126,  -126,  -126,   397,
      55,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,
    -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,
     436,   174,    37,   174,  -126,  -126,  -126,     3,    63,    19,
      58,  -126,    76,  -126,  -126,    73,  -126,  -126,     1,  -126,
    -126,   397,   121,  -126,    -5,   101,    42,   109,   102,    15,
     113,    27,    53,  -126,  -126,    -4,  -126,  -126,  -126,     2,
     137,  -126,    17,    12,  -126,  -126,  -126,  -126,  -126,   202,
     241,   280,   319,   397,   358,   397,    80,    96,  -126,  -126,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,  -126,
    -126,  -126,  -126,   146,   169,   176,  -126,  -126,  -126,   182,
     137,   186,  -126,  -126,  -126,  -126,   178,  -126,    87,   189,
     397,    35,  -126,   397,  -126,  -126,    30,  -126,    74,  -126,
      86,  -126,    88,    25,  -126,   100,   183,  -126,  -126,  -126,
     198,   101,    42,   109,   102,    15,   113,   113,    27,    27,
      27,    27,    53,    53,  -126,  -126,  -126,  -126,  -126,   397,
      -1,   397,  -126,  -126,   137,   397,   397,  -126,  -126,  -126,
    -126,  -126,  -126,  -126,  -126,  -126,  -126,   475,   397,   475,
    -126,   397,   193,   134,  -126,   397,  -126,  -126,  -126,  -126,
    -126,  -126,   397,   217,    37,   218,   228,   235,  -126,  -126,
    -126,   397,  -126,  -126,  -126,  -126,   397,  -126,  -126,  -126,
      55,    55,    55,    55,  -126,   195,  -126,  -126,  -126,     5,
    -126,  -126,  -126
  };

  const unsigned char
   Parser ::yydefact_[] =
  {
       6,     6,     6,     6,     0,    25,     3,     4,     5,     1,
      25,     8,    27,    12,    13,     2,     7,    10,    25,     0,
       0,    18,    22,    23,    29,    20,    21,    19,   123,   124,
     125,   122,    16,    15,    28,    17,   126,    24,    14,    11,
       0,     0,    85,     0,    82,    84,    83,    59,   124,    60,
      55,    57,   137,   139,   121,    58,    62,    65,    77,    68,
     116,     0,     0,    86,    87,    89,    91,    93,    95,    97,
      99,   102,   107,   110,    56,     0,    70,   141,   140,    63,
      34,     9,    55,     0,    73,    78,   120,    74,    79,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    76,    26,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    81,
      80,    71,    72,     0,     0,     0,    42,    41,    40,     0,
      34,    32,    38,    35,    36,    39,    68,    37,   141,   140,
       0,     0,    61,     0,   133,   143,     0,   127,     0,   129,
       0,   131,     0,     0,   135,     0,     0,    75,    66,    67,
       0,    90,    92,    94,    96,    98,   100,   101,   103,   104,
     105,   106,   108,   109,   111,   112,   113,   114,   115,     0,
       0,     0,    30,    33,    34,     0,     0,   144,   153,   152,
     149,   151,   148,   150,   145,   146,   147,     0,     0,     0,
     117,     0,     0,     0,   134,     0,   128,   130,   132,   138,
     136,    69,     0,     0,     0,     0,     0,     0,    31,    50,
      51,     0,    53,    52,    54,   118,     0,    64,   142,    88,
       0,     0,     0,     0,   119,    46,    44,    43,    45,     0,
      48,    49,    47
  };

  const short
   Parser ::yypgoto_[] =
  {
    -126,  -126,   212,  -126,   242,  -126,   236,  -126,  -126,   -12,
       0,  -125,  -126,  -126,  -126,  -126,    18,  -126,  -126,  -126,
    -126,   -79,   -49,  -126,   -19,    41,  -126,   155,   156,   157,
     162,   154,   -29,    62,    -9,   -52,    81,    -7,  -126,   -77,
     -76,   120,   -75,   128
  };

  const unsigned char
   Parser ::yydefgoto_[] =
  {
       0,     4,     5,    10,    11,    12,    13,    14,    20,    56,
      81,   129,   130,   131,   132,   133,   134,   242,   135,    57,
      58,    59,    60,    61,   145,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,   146,   197
  };

  const short
   Parser ::yytable_[] =
  {
      62,   136,    37,   138,   139,   183,   100,    38,    95,    98,
      80,    17,    89,    24,     9,   148,   150,   152,   153,   155,
     101,    83,   142,   119,    18,   143,    92,   140,    91,   121,
    -123,   106,   107,   209,    84,   120,    87,   214,   205,    15,
     204,   122,  -123,   205,  -122,   201,  -125,   112,   113,    96,
      97,   136,    19,   138,   139,   123,  -122,   141,  -125,   218,
      80,   137,   174,   175,   176,   177,   178,    92,   203,    21,
      34,    54,    90,    22,    23,   202,   156,   166,   167,   114,
      24,   160,    94,    93,   206,  -122,   103,   205,   200,   158,
     159,   115,    25,   116,   117,   118,   207,  -122,   208,   205,
    -126,   205,   186,   172,   173,   136,    26,   138,   139,    86,
     210,   137,  -126,   205,    27,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   102,    28,    29,    30,    31,
      32,   108,   109,    99,    33,   110,   111,    34,    35,    36,
      28,    29,    30,    31,   227,   105,    40,   205,   222,   225,
     224,    24,   157,    36,   104,   179,    28,    29,    30,    31,
     213,    85,   217,    88,    41,   137,   219,   220,   215,    36,
     168,   169,   170,   171,   234,    42,    43,    44,   180,   223,
       1,     2,     3,    45,    46,   181,   228,   123,   182,   124,
     184,   211,   125,   185,   126,   127,   128,    47,    48,    49,
      50,   212,    83,   226,   198,    51,    52,    53,    34,    54,
      55,    40,   144,     6,     7,     8,    24,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   230,   231,    41,
     235,   236,   237,   238,    28,    29,    30,    31,   232,   240,
      42,    43,    44,    52,    53,   233,   239,    36,    45,    46,
      40,   147,    16,   229,    39,    24,   161,   241,   162,   165,
     163,   216,    47,    48,    49,    50,   164,   199,    41,     0,
      51,    52,    53,    34,    54,    55,     0,     0,     0,    42,
      43,    44,     0,     0,     0,     0,     0,    45,    46,    40,
     149,     0,     0,     0,    24,     0,     0,     0,     0,     0,
       0,    47,    48,    49,    50,     0,     0,    41,     0,    51,
      52,    53,    34,    54,    55,     0,     0,     0,    42,    43,
      44,     0,     0,     0,     0,     0,    45,    46,    40,   151,
       0,     0,     0,    24,     0,     0,     0,     0,     0,     0,
      47,    48,    49,    50,     0,     0,    41,     0,    51,    52,
      53,    34,    54,    55,     0,     0,     0,    42,    43,    44,
       0,     0,     0,     0,     0,    45,    46,    40,   154,     0,
       0,     0,    24,     0,     0,     0,     0,     0,     0,    47,
      48,    49,    50,     0,     0,    41,     0,    51,    52,    53,
      34,    54,    55,     0,     0,     0,    42,    43,    44,     0,
       0,     0,     0,     0,    45,    46,    40,     0,     0,     0,
       0,    24,     0,     0,     0,     0,     0,     0,    47,    48,
      49,    50,     0,     0,    41,     0,    51,    52,    53,    34,
      54,    55,     0,     0,     0,    42,    43,    44,     0,     0,
       0,     0,     0,    45,    46,    40,     0,     0,     0,     0,
      24,     0,     0,     0,     0,     0,     0,    47,    48,    49,
      50,     0,     0,    41,     0,    51,    52,    53,    34,    54,
      55,     0,     0,     0,    42,    43,    44,     0,     0,     0,
       0,     0,    45,    46,   221,     0,     0,     0,     0,    24,
       0,     0,     0,     0,     0,     0,    47,    48,    49,    82,
       0,     0,    41,     0,    51,    52,    53,    34,    54,    55,
       0,     0,     0,    42,    43,    44,     0,     0,     0,     0,
       0,    45,    46,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    47,    48,    49,    50,     0,
       0,     0,     0,    51,    52,    53,    34,    54,    55
  };

  const short
   Parser ::yycheck_[] =
  {
      19,    80,    14,    80,    80,   130,    11,    14,     7,    61,
       5,     0,     9,    14,     0,    90,    91,    92,    93,    94,
      25,    40,    10,    27,    13,    13,     9,    10,     9,    27,
      27,    16,    17,     8,    41,    39,    43,    38,    13,     0,
      10,    39,    39,    13,    27,    10,    27,    20,    21,    48,
      49,   130,    41,   130,   130,    50,    39,    40,    39,   184,
       5,    80,   114,   115,   116,   117,   118,     9,   143,     3,
      71,    72,     9,     7,     8,    40,    95,   106,   107,    26,
      14,   100,     9,     7,    10,    27,    44,    13,   140,    96,
      97,    38,    26,    40,    41,    42,    10,    39,    10,    13,
      27,    13,    15,   112,   113,   184,    40,   184,   184,    72,
      10,   130,    39,    13,    48,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    24,    60,    61,    62,    63,
      64,    18,    19,    12,    68,    22,    23,    71,    72,    73,
      60,    61,    62,    63,    10,    43,     9,    13,   197,   201,
     199,    14,    72,    73,    45,     9,    60,    61,    62,    63,
     179,    41,   181,    43,    27,   184,   185,   186,   180,    73,
     108,   109,   110,   111,   226,    38,    39,    40,     9,   198,
      65,    66,    67,    46,    47,     9,   205,    50,     6,    52,
       4,     8,    55,    15,    57,    58,    59,    60,    61,    62,
      63,     3,   221,    10,    15,    68,    69,    70,    71,    72,
      73,     9,    10,     1,     2,     3,    14,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    10,    10,    27,
     230,   231,   232,   233,    60,    61,    62,    63,    10,   239,
      38,    39,    40,    69,    70,    10,    51,    73,    46,    47,
       9,    10,    10,   212,    18,    14,   101,   239,   102,   105,
     103,   180,    60,    61,    62,    63,   104,   139,    27,    -1,
      68,    69,    70,    71,    72,    73,    -1,    -1,    -1,    38,
      39,    40,    -1,    -1,    -1,    -1,    -1,    46,    47,     9,
      10,    -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    60,    61,    62,    63,    -1,    -1,    27,    -1,    68,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    38,    39,
      40,    -1,    -1,    -1,    -1,    -1,    46,    47,     9,    10,
      -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      60,    61,    62,    63,    -1,    -1,    27,    -1,    68,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    38,    39,    40,
      -1,    -1,    -1,    -1,    -1,    46,    47,     9,    10,    -1,
      -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,    60,
      61,    62,    63,    -1,    -1,    27,    -1,    68,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    38,    39,    40,    -1,
      -1,    -1,    -1,    -1,    46,    47,     9,    -1,    -1,    -1,
      -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,
      62,    63,    -1,    -1,    27,    -1,    68,    69,    70,    71,
      72,    73,    -1,    -1,    -1,    38,    39,    40,    -1,    -1,
      -1,    -1,    -1,    46,    47,     9,    -1,    -1,    -1,    -1,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,    62,
      63,    -1,    -1,    27,    -1,    68,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    38,    39,    40,    -1,    -1,    -1,
      -1,    -1,    46,    47,     9,    -1,    -1,    -1,    -1,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    60,    61,    62,    63,
      -1,    -1,    27,    -1,    68,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    38,    39,    40,    -1,    -1,    -1,    -1,
      -1,    46,    47,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    60,    61,    62,    63,    -1,
      -1,    -1,    -1,    68,    69,    70,    71,    72,    73
  };

  const signed char
   Parser ::yystos_[] =
  {
       0,    65,    66,    67,    75,    76,    76,    76,    76,     0,
      77,    78,    79,    80,    81,     0,    78,     0,    13,    41,
      82,     3,     7,     8,    14,    26,    40,    48,    60,    61,
      62,    63,    64,    68,    71,    72,    73,    83,   111,    80,
       9,    27,    38,    39,    40,    46,    47,    60,    61,    62,
      63,    68,    69,    70,    72,    73,    83,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
       5,    84,    63,    98,   111,   115,    72,   111,   115,     9,
       9,     9,     9,     7,     9,     7,    48,    49,   109,    12,
      11,    25,    24,    44,    45,    43,    16,    17,    18,    19,
      22,    23,    20,    21,    26,    38,    40,    41,    42,    27,
      39,    27,    39,    50,    52,    55,    57,    58,    59,    85,
      86,    87,    88,    89,    90,    92,    95,    98,   113,   114,
      10,    40,    10,    13,    10,    98,   116,    10,   116,    10,
     116,    10,   116,   116,    10,   116,    98,    72,   111,   111,
      98,   101,   102,   103,   104,   105,   106,   106,   107,   107,
     107,   107,   108,   108,   109,   109,   109,   109,   109,     9,
       9,     9,     6,    85,     4,    15,    15,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,   117,    15,   117,
     109,    10,    40,   116,    10,    13,    10,    10,    10,     8,
      10,     8,     3,    98,    38,    83,   110,    98,    85,    98,
      98,     9,    96,    98,    96,   109,    10,    10,    98,    99,
      10,    10,    10,    10,   109,    84,    84,    84,    84,    51,
      84,    90,    91
  };

  const signed char
   Parser ::yyr1_[] =
  {
       0,    74,    75,    76,    76,    76,    76,    77,    77,    78,
      78,    79,    79,    80,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    81,    81,    82,    82,    83,    83,
      84,    85,    85,    85,    85,    86,    86,    87,    87,    87,
      88,    88,    88,    89,    89,    89,    90,    90,    91,    91,
      92,    92,    92,    92,    92,    93,    93,    93,    93,    93,
      93,    93,    93,    93,    93,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    94,    95,    96,    96,    96,    96,
      96,    96,    97,    97,    97,    97,    98,    99,    99,   100,
     100,   101,   101,   102,   102,   103,   103,   104,   104,   105,
     105,   105,   106,   106,   106,   106,   106,   107,   107,   107,
     108,   108,   108,   108,   108,   108,   109,   109,   109,   109,
     110,   110,   111,   111,   111,   111,   111,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   113,   113,   114,
     115,   115,   116,   116,   117,   117,   117,   117,   117,   117,
     117,   117,   117,   117
  };

  const signed char
   Parser ::yyr2_[] =
  {
       0,     2,     3,     2,     2,     2,     0,     2,     1,     3,
       2,     3,     1,     1,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     0,     3,     0,     1,     1,
       3,     3,     1,     2,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     5,     5,     5,     5,     7,     1,     1,
       3,     3,     3,     3,     3,     1,     1,     1,     1,     1,
       1,     3,     1,     1,     5,     1,     3,     3,     1,     4,
       1,     2,     2,     2,     2,     3,     2,     1,     2,     2,
       2,     2,     1,     1,     1,     1,     1,     1,     5,     1,
       3,     1,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     3,     1,     3,     3,     3,     3,     1,     3,     3,
       1,     3,     3,     3,     3,     3,     1,     4,     5,     6,
       2,     1,     1,     1,     1,     1,     1,     3,     4,     3,
       4,     3,     4,     3,     4,     3,     4,     1,     4,     1,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const  Parser ::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "\":\"", "\";\"",
  "\"{\"", "\"}\"", "\"[\"", "\"]\"", "\"(\"", "\")\"", "\"?\"",
  "\"end predicate\"", "\",\"", "\"$#\"", "\"=\"", "\"==\"", "\"!=\"",
  "\"<=\"", "\">=\"", "\"<<\"", "\">>\"", "\"<\"", "\">\"", "\"&&\"",
  "\"||\"", "\"+\"", "\"++\"", "\"<<=\"", "\">>=\"", "\"+=\"", "\"-=\"",
  "\"*=\"", "\"/=\"", "\"%=\"", "\"&=\"", "\"|=\"", "\"^=\"", "\"-\"",
  "\"--\"", "\"*\"", "\"/\"", "\"%\"", "\"&\"", "\"|\"", "\"^\"", "\"!\"",
  "\"~\"", "\".\"", "\"->\"", "\"if\"", "\"else\"", "\"unroll\"",
  "\"struct\"", "\"union\"", "\"while\"", "\"for\"", "\"return\"",
  "\"continue\"", "\"break\"", "\"builtin\"", "\"call\"",
  "\"call_builtin\"", "\"identifier\"", "\"path\"",
  "\"preprocessor directive\"", "\"struct definition\"", "\"enum\"",
  "\"string\"", "\"map\"", "\"variable\"", "\"positional parameter\"",
  "\"integer\"", "\"stack_mode\"", "$accept", "program", "c_definitions",
  "probes", "probe", "attach_points", "attach_point", "attach_point_def",
  "pred", "param", "block", "stmt_list", "block_stmt", "expr_stmt",
  "jump_stmt", "loop_stmt", "if_stmt", "block_or_if", "assign_stmt",
  "primary_expr", "postfix_expr", "tuple_access_expr", "unary_expr",
  "unary_op", "expr", "conditional_expr", "logical_or_expr",
  "logical_and_expr", "or_expr", "xor_expr", "and_expr", "equality_expr",
  "relational_expr", "shift_expr", "arith_expr", "cast_expr", "int",
  "ident", "call", "map", "var", "map_or_var", "vargs", "compound_op", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
   Parser ::yyrline_[] =
  {
       0,   162,   162,   166,   167,   168,   169,   173,   174,   178,
     188,   201,   202,   206,   210,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   236,   240,   241,   246,   257,
     261,   268,   269,   273,   274,   278,   279,   283,   284,   289,
     293,   294,   295,   299,   300,   301,   305,   306,   310,   311,
     315,   320,   321,   322,   327,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   354,   356,   357,   359,   361,
     362,   363,   364,   366,   367,   372,   378,   379,   380,   381,
     383,   384,   388,   389,   390,   391,   395,   399,   400,   405,
     406,   410,   411,   415,   416,   420,   421,   426,   427,   431,
     432,   433,   437,   438,   439,   440,   441,   445,   446,   447,
     451,   452,   453,   454,   455,   456,   460,   461,   462,   463,
     467,   468,   472,   473,   474,   475,   476,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   493,   494,   498,
     502,   503,   507,   508,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521
  };

  void
   Parser ::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
   Parser ::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


#line 4 "src/parser.yy"
} //  bpftrace 
#line 2752 "/builddir/build/BUILD/bpftrace-0.14.0/redhat-linux-build/parser.tab.cc"

#line 524 "src/parser.yy"


void bpftrace::Parser::error(const location &l, const std::string &m)
{
  driver.error(l, m);
}
